Index: aim.c
===================================================================
--- aim.c	(revision e3e6cff9f72f2e4f2c72c2a48f95e45db859298d)
+++ aim.c	(revision c675b3959f4b4476da37b65a66b27fa38163c845)
@@ -130,4 +130,11 @@
 }
 
+void owl_aim_send_nop(owl_timer *t, void *data) {
+    if(owl_global_is_doaimevents(&g)) {
+        aim_session_t *sess = owl_global_get_aimsess(&g);
+        aim_flap_nop(sess, aim_getconn_type(sess, AIM_CONN_TYPE_BOS));
+    }
+}
+
 
 int owl_aim_login(char *screenname, char *password)
@@ -194,5 +201,11 @@
   owl_function_debugmsg("owl_aim_login: connecting");
 
+  g.aim_nop_timer = owl_select_add_timer(30, 30, owl_aim_send_nop, NULL, NULL);
+
   return(0);
+}
+
+void owl_aim_unset_ignorelogin(owl_timer *t, void *data) {      /* noproto */
+    owl_global_unset_ignore_aimlogin(&g);
 }
 
@@ -212,8 +225,8 @@
 
   /* start the ingorelogin timer */
-  owl_timer_reset_newstart(owl_global_get_aim_login_timer(&g),
-			   owl_global_get_aim_ignorelogin_timer(&g));
-
-  
+  owl_global_set_ignore_aimlogin(&g);
+  owl_select_add_timer(owl_global_get_aim_ignorelogin_timer(&g),
+                       0, owl_aim_unset_ignorelogin, NULL, NULL);
+
   /* aim_ssi_setpresence(owl_global_get_aimsess(&g), 0x00000400); */
   /* aim_bos_setidle(owl_global_get_aimsess(&g), owl_global_get_bosconn(&g), 5000); */
@@ -228,4 +241,5 @@
   owl_global_set_aimnologgedin(&g);
   owl_global_set_no_doaimevents(&g);
+  owl_select_remove_timer(g.aim_nop_timer);
 }
 
@@ -239,5 +253,5 @@
 {
   if (message) {
-    owl_function_error(message);
+    owl_function_error("%s", message);
   } else {
     owl_function_error("Authentication error on login");
@@ -246,4 +260,5 @@
   owl_global_set_aimnologgedin(&g);
   owl_global_set_no_doaimevents(&g);
+  owl_select_remove_timer(g.aim_nop_timer);
 }
 
@@ -252,5 +267,5 @@
   int ret;
 
-  ret=aim_im_sendch1(owl_global_get_aimsess(&g), to, NULL, msg);
+  ret=aim_im_sendch1(owl_global_get_aimsess(&g), to, 0, msg);
     
   /* I don't know how to check for an error yet */
@@ -422,9 +437,4 @@
   tv.tv_usec = 0;
   waitingconn = aim_select(aimsess, &tv, &selstat);
-
-  if (owl_global_is_aimnop_time(&g)) {
-    aim_flap_nop(aimsess, aim_getconn_type(aimsess, AIM_CONN_TYPE_BOS));
-    owl_global_aimnop_sent(&g);
-  }
 
   if (selstat == -1) {
@@ -1698,5 +1708,5 @@
   
   /* printf("snac threw error (reason 0x%04x: %s)\n", reason, (reason<msgerrreasonslen)?msgerrreasons[reason]:"unknown"); */
-  if (reason<msgerrreasonslen) owl_function_error(msgerrreasons[reason]);
+  if (reason<msgerrreasonslen) owl_function_error("%s", msgerrreasons[reason]);
   
   return 1;
@@ -1715,5 +1725,5 @@
   
   /* printf("message to %s bounced (reason 0x%04x: %s)\n", destsn, reason, (reason<msgerrreasonslen)?msgerrreasons[reason]:"unknown"); */
-  if (reason<msgerrreasonslen) owl_function_error(msgerrreasons[reason]);
+  if (reason<msgerrreasonslen) owl_function_error("%s", msgerrreasons[reason]);
 
   if (reason==4) {
@@ -1736,5 +1746,5 @@
   
   /* printf("user information for %s unavailable (reason 0x%04x: %s)\n", destsn, reason, (reason<msgerrreasonslen)?msgerrreasons[reason]:"unknown"); */
-  if (reason<msgerrreasonslen) owl_function_error(msgerrreasons[reason]);
+  if (reason<msgerrreasonslen) owl_function_error("%s", msgerrreasons[reason]);
   
   return 1;
@@ -2309,4 +2319,11 @@
   aim_sendcookie(sess, tstconn, redir->cookielen, redir->cookie);
   return;	
+}
+
+void owl_process_aim()
+{
+  if (owl_global_is_doaimevents(&g)) {
+    owl_aim_process_events();
+  }
 }
 
Index: buddylist.c
===================================================================
--- buddylist.c	(revision 257a22f9949fe230526eb336a3d6c236f702da66)
+++ buddylist.c	(revision b7bb4545f69af6f073e4844a0cc06b07c8a11873)
@@ -51,5 +51,5 @@
 
     /* are we ingoring login messages for a while? */
-    if (!owl_timer_is_expired(owl_global_get_aim_login_timer(&g))) return;
+    if (owl_global_is_ignore_aimlogin(&g)) return;
 
     /* if not, create the login message */
Index: commands.c
===================================================================
--- commands.c	(revision 451db9e0515b2671c88e0858f712b53a7fcc5b76)
+++ commands.c	(revision f34dd65b3adbc2eedc045a674dd89b7e20257680)
@@ -453,11 +453,4 @@
   OWLCMD_VOID("pop-message", owl_command_pop_message, OWL_CTX_RECWIN,
 	      "pops up a message in a window", "", ""),
-
-  OWLCMD_VOID("openurl", owl_command_openurl, OWL_CTX_INTERACTIVE,
-	      "opens up a URL from the current message",
-	      "", 
-	      "Uses the 'webbrowser' variable to determine\n"
-	      "which browser to use.  Currently, 'netscape'\n"
-	      "and 'galeon' are supported.\n"),
 
   OWLCMD_ARGS("zaway", owl_command_zaway, OWL_CTX_INTERACTIVE,
@@ -641,4 +634,5 @@
 	      "show keymap <keymap>\n"
 	      "show license\n"
+	      "show quickstart\n"
 	      "show startup\n"
 	      "show status\n"
@@ -1046,8 +1040,5 @@
 void owl_command_version()
 {
-  char buff[1024];
-
-  sprintf(buff, "Owl version %s", OWL_VERSION_STRING);
-  owl_function_makemsg(buff);
+  owl_function_makemsg("BarnOwl version %s", OWL_VERSION_STRING);
 }
 
@@ -1461,5 +1452,5 @@
     owl_function_aaway_on();
     owl_function_zaway_on();
-    owl_function_makemsg("Away messages set.", owl_global_get_aaway_msg_default(&g));
+    owl_function_makemsg("Away messages set.");
     return NULL;
   }
@@ -1691,5 +1682,5 @@
   }
 
-  owl_function_debugmsg(argv[1]);
+  owl_function_debugmsg("%s", argv[1]);
   return(NULL);
 }
@@ -1735,11 +1726,4 @@
   return(NULL);
 }
-
-
-void owl_command_zlog_out(void)
-{
-  owl_zephyr_zlog_out();
-}
-
 
 char *owl_command_subscribe(int argc, char **argv, char *buff)
@@ -2207,4 +2191,6 @@
   } else if (!strcmp(argv[1], "license")) {
     owl_function_show_license();
+  } else if (!strcmp(argv[1], "quickstart")) {
+    owl_function_show_quickstart();
   } else if (!strcmp(argv[1], "startup")) {
     char *filename;
@@ -2251,9 +2237,4 @@
 {
   owl_function_curmsg_to_popwin();
-}
-
-void owl_command_openurl(void)
-{
-  owl_function_openurl();
 }
 
@@ -2580,5 +2561,5 @@
 {
     buff = skiptokens(buff, 1);
-    owl_function_error(buff);
+    owl_function_error("%s", buff);
     return NULL;
 }
@@ -2587,5 +2568,5 @@
 {
     buff = skiptokens(buff, 1);
-    owl_function_makemsg(buff);
+    owl_function_makemsg("%s", buff);
     return NULL;
 }
Index: configure.ac
===================================================================
--- configure.ac	(revision d9337637b38624a9f8d064c1a45062f7762f7b72)
+++ configure.ac	(revision d54035d6066afecc509f9a5d444f39a5c0b6725c)
@@ -46,5 +46,5 @@
 fi
 
-AC_CHECK_LIB(ncursesw, initscr,, AC_MSG_ERROR(No curses library found.))
+AC_CHECK_LIB(ncursesw, initscr,, AC_MSG_ERROR(No libncursesw found.))
 AC_CHECK_LIB(com_err, com_err)
 AC_CHECK_LIB(nsl, gethostbyname)
Index: editwin.c
===================================================================
--- editwin.c	(revision e9bb404064914673e4c9588dccf789ce2c5d2fbc)
+++ editwin.c	(revision 50e671ca58bb9d2a3f7ca0cac269bc966a246a95)
@@ -1042,4 +1042,9 @@
     if (e->buff[i] == '\n' && e->buff[i+1] == '\n') break;
 
+    /* bail if we hit a trailing dot on the buffer */
+    if (e->buff[i] == '\n' && e->buff[i+1] == '.'
+        && ((i+2) >= e->bufflen || e->buff[i+2] == '\0'))
+      break;
+
     /* if we've travelled too far, linewrap */
     if ((e->buffx) >= e->fillcol) {
Index: examples/owlconf.erik
===================================================================
--- examples/owlconf.erik	(revision 5d9c664a3ac870215d4deea22ef3d0be2978f94a)
+++ examples/owlconf.erik	(revision 4f15e8e9ceada0d4b2cc969ebf43b0a1fb3709ea)
@@ -147,7 +147,4 @@
     owl::command("set -q rxping on");
     owl::command("set -q typewinsize 5");
-    if ($ENV{"DISPLAY"} eq ":0.0") {
-      owl::command("set -q webbrowser galeon");	
-    }
     owl::command("filter me recipient %me% or ( sender %me% and class message and instance personal ) or class mail or type aim");
     owl::command("filter owl instance ^owl.*");
Index: examples/owlconf.simple
===================================================================
--- examples/owlconf.simple	(revision 2b14303f3f167f4a8fb4ed6f1141d62cdf13e433)
+++ examples/owlconf.simple	(revision 4f15e8e9ceada0d4b2cc969ebf43b0a1fb3709ea)
@@ -93,9 +93,4 @@
     # owl::command('set -q view_home all');
 
-
-    ## Which webbrowser to use to launch URLs with the 'w' key.
-    # owl::command('set -q webbrowser netscape');
-    # owl::command('set -q webbrowser galeon');
-    # owl::command('set -q webbrowser none');
 
     ## Default message to send when zaway is on (toggle with 'A')
Index: filter.c
===================================================================
--- filter.c	(revision cdc6ff1af792c6ba025214d1b7f310e652c420d7)
+++ filter.c	(revision f34dd65b3adbc2eedc045a674dd89b7e20257680)
@@ -3,6 +3,4 @@
 
 static const char fileIdent[] = "$Id$";
-
-#define OWL_FILTER_MAXRECURSE 20
 
 int owl_filter_init_fromstring(owl_filter *f, char *name, char *string)
@@ -20,5 +18,4 @@
 {
   f->name=owl_strdup(name);
-  f->polarity=0;
   f->fgcolor=OWL_COLOR_DEFAULT;
   f->bgcolor=OWL_COLOR_DEFAULT;
@@ -50,5 +47,5 @@
   /* Now check for recursion. */
   if (owl_filter_is_toodeep(f)) {
-    owl_function_error("Filter loop or exceeds recursion depth");
+    owl_function_error("Filter loop!");
     owl_filter_free(f);
     return(-1);
@@ -159,14 +156,4 @@
 }
 
-void owl_filter_set_polarity_match(owl_filter *f)
-{
-  f->polarity=0;
-}
-
-void owl_filter_set_polarity_unmatch(owl_filter *f)
-{
-  f->polarity=1;
-}
-
 void owl_filter_set_fgcolor(owl_filter *f, int color)
 {
@@ -207,5 +194,4 @@
   if(!f->root) return 0;
   ret = owl_filterelement_match(f->root, m);
-  if(f->polarity) ret = !ret;
   return ret;
 }
@@ -313,5 +299,5 @@
   int numfailed=0;
   owl_message m;
-  owl_filter f1, f2, f3, f4;
+  owl_filter f1, f2, f3, f4, f5;
 
   owl_list_create(&(g.filterlist));
@@ -365,4 +351,7 @@
   FAIL_UNLESS("mutual recursion",   owl_filter_init_fromstring(&f4, "f4", "filter f3"));
 
+  /* support referencing a filter several times */
+  FAIL_UNLESS("DAG", !owl_filter_init_fromstring(&f5, "dag", "filter f1 or filter f1"));
+
   return 0;
 }
Index: filterelement.c
===================================================================
--- filterelement.c	(revision 0504f6318cdf8fe825d6783bd0909a68afded8bb)
+++ filterelement.c	(revision f4464544a8d8ed67998d75c5715219161f0bae5f)
@@ -279,30 +279,43 @@
 }
 
+static int fe_visiting = 0;
+static int fe_visited  = 1;
+
 int owl_filterelement_is_toodeep(owl_filter *f, owl_filterelement *fe)
 {
-  int one = 1;
-  owl_list nodes;
+  int rv;
   owl_dict filters;
-  owl_list_create(&nodes);
   owl_dict_create(&filters);
-  
-  owl_list_append_element(&nodes, fe);
-  owl_dict_insert_element(&filters, f->name, &one, NULL);
-  while(owl_list_get_size(&nodes)) {
-    fe = owl_list_get_element(&nodes, 0);
-    owl_list_remove_element(&nodes, 0);
-    if(fe->left) owl_list_append_element(&nodes, fe->left);
-    if(fe->right) owl_list_append_element(&nodes, fe->right);
-    if(fe->match_message == owl_filterelement_match_filter) {
-      if(owl_dict_find_element(&filters, fe->field)) return 1;
-      owl_dict_insert_element(&filters, fe->field, &one, NULL);
+
+  owl_dict_insert_element(&filters, f->name, &fe_visiting, owl_dict_noop_free);
+
+  rv = _owl_filterelement_is_toodeep(fe, &filters);
+
+  owl_dict_free_simple(&filters);
+  return rv;
+}
+
+int _owl_filterelement_is_toodeep(owl_filterelement *fe, owl_dict *seen)
+{
+  int rv = 0;
+  owl_filter *f;
+
+  if(fe->match_message == owl_filterelement_match_filter) {
+    int *nval = owl_dict_find_element(seen, fe->field);
+    if(nval == &fe_visiting) {
+      return 1;
+    } else if (nval == NULL) {
       f = owl_global_get_filter(&g, fe->field);
-      if(f) owl_list_append_element(&nodes, f->root);
+      owl_dict_insert_element(seen, fe->field, &fe_visiting, owl_dict_noop_free);
+      if(f) rv = _owl_filterelement_is_toodeep(f->root, seen);
+      owl_dict_insert_element(seen, fe->field, &fe_visited, owl_dict_noop_free);
     }
-  }
-
-  owl_list_free_simple(&nodes);
-  owl_dict_free_simple(&filters);
-  return 0;
+  } else {
+    if(fe->left)
+      rv = rv || _owl_filterelement_is_toodeep(fe->left, seen);
+    if(fe->right)
+      rv = rv || _owl_filterelement_is_toodeep(fe->right, seen);
+  }
+  return rv;
 }
 
Index: fmtext.c
===================================================================
--- fmtext.c	(revision 6f6330b75dc25a4ca924840a42b64e3ae965435e)
+++ fmtext.c	(revision 14903270d4a34ee12357613525f0870544bc6915)
@@ -90,4 +90,18 @@
 }
 
+/* Append normal, uncolored text specified by format string to 'f' */
+void owl_fmtext_appendf_normal(owl_fmtext *f, char *fmt, ...)
+{
+  va_list ap;
+  char *buff;
+
+  va_start(ap, fmt);
+  buff = g_strdup_vprintf(fmt, ap);
+  va_end(ap);
+  if (!buff)
+    return;
+  owl_fmtext_append_attr(f, buff, OWL_FMTEXT_ATTR_NONE, OWL_COLOR_DEFAULT, OWL_COLOR_DEFAULT);
+}
+
 /* Append normal text 'text' to 'f' with color 'color' */
 void owl_fmtext_append_normal_color(owl_fmtext *f, char *text, int fgcolor, int bgcolor)
@@ -169,5 +183,6 @@
 
 /* Internal function.  Append text from 'in' between index 'start' and
- * 'stop' to the end of 'f'
+ * 'stop', inclusive, to the end of 'f'. This function works with
+ * bytes.
  */
 void _owl_fmtext_append_fmtext(owl_fmtext *f, owl_fmtext *in, int start, int stop) /*noproto*/
@@ -474,14 +489,15 @@
 	_owl_fmtext_append_fmtext(out, in, ptr_s - in->textbuff, ptr_c - in->textbuff);
       }
+      else if (chwidth > 1) {
+        /* Last char is wide, truncate. */
+        _owl_fmtext_append_fmtext(out, in, ptr_s - in->textbuff, ptr_c - in->textbuff - 1);
+        owl_fmtext_append_normal(out, "\n");
+      }
       else {
-	if (chwidth > 1) {
-	  /* Last char is wide, truncate. */
-	  _owl_fmtext_append_fmtext(out, in, ptr_s - in->textbuff, ptr_c - in->textbuff - 1);
-	  owl_fmtext_append_normal(out, "\n");
-	}
-	else {
-	  /* Last char fits perfectly, leave alone.*/
-	  _owl_fmtext_append_fmtext(out, in, ptr_s - in->textbuff, ptr_c - in->textbuff);
-	}
+        /* Last char fits perfectly, We skip to the next char and back
+         * up a byte to make sure we get it all.
+         */
+        ptr_c = g_utf8_next_char(ptr_c);
+        _owl_fmtext_append_fmtext(out, in, ptr_s - in->textbuff, ptr_c - in->textbuff - 1);
       }
     }
@@ -763,8 +779,8 @@
  * If format_fn is specified, passes it the list element value
  * and it will return a string which this needs to free. */
-void owl_fmtext_append_list(owl_fmtext *f, owl_list *l, char *join_with, char *(format_fn)(void*))
+void owl_fmtext_append_list(owl_fmtext *f, owl_list *l, char *join_with, char *(format_fn)(char *))
 {
   int i, size;
-  void *elem;
+  char *elem;
   char *text;
 
